# Seliz Gulsen Karadogan
# Technical University of Denmark
# January 2012

$input_arff = $ARGV[0];
if ($ARGV[1]) {$output = $ARGV[1]};
if ($ARGV[2]) {$fsel_arff = $ARGV[2]};

my @attr = ();

open(OUT,">$output");
print OUT "\@relation 'SMILEfeatures-weka.filters.supervised.attribute.AttributeSelection-Eweka.attributeSelection.CfsSubsetEval-Sweka.attributeSelection.BestFirst -D 1 -N 5'\n\n";
open(FILE,"<$fsel_arff");
while (<FILE>) {
  my $line = $_; chop($line);
  if ($line =~ /^\@attribute (.+?) numeric/) {
    $nStr++; 
    push (@attr, $line); 
    print OUT "$line\n";
  } 
  if ($line =~ /^\@attribute emotion (.+?)/) { print OUT "$line\n";}
  if ($line =~ /^\@data/) { last; }
}

print OUT "\n\@data\n\n";
close(FILE);



my @index=();
open(FILE,"<$input_arff");
$j=0;
while (<FILE>) {
  my $line = $_; chop($line);
  if ($line =~ /^\@attribute (.+?) numeric/) {
          $i=0;
     $len_attr=@attr;
     while ($i<=$len_attr){
      
      if ($line eq @attr[$i])
       {
       @index[$i]=$j;
       }
       $i= $i+1;
     }
    $j=$j+1;
  }
  if ($line =~ /^\@data/) { last; }
}


while (<FILE>) {
  my $line = $_; chop($line);
  @splitted = split(/,/, $line);
  if (@splitted[0] ne ""){
    $i=0;
  $len_attr=@index;
  while ($i<=$len_attr-1){
    if (@splitted[0] =~ /(.+?)/ ){
      print OUT "@splitted[@index[$i]+1]";
      print OUT ",";
    }
    else {
      print OUT "@splitted[@index[$i]]";
      print OUT ",";
    }
    
    $i=$i+1;
  }
  my $val = pop @splitted;
  print OUT "$val\n";
  }
}

close(OUT);


